package com.fs.task.service;

import java.math.BigDecimal;
import java.util.List;
import com.fs.task.domain.TaskInfo;
import com.fs.task.dto.TaskDeliveryDto;
import com.fs.task.dto.TaskStatsDTO;
import com.fs.task.vo.GetTaskCompleteStatsVO;
import com.fs.task.vo.TaskCreateAuditReqVO;
import com.fs.task.vo.TaskFinishAuditReqVO;
import com.fs.task.vo.TaskInfoCreateVO;
import com.fs.task.vo.TaskSpotCheckUpdateReqVO;
import com.fs.task.vo.audit_Info.TaskAuditInfoVO;

import javax.validation.Valid;

/**
 * 任务信息Service接口
 *
 * @author fs
 * @date 2026-01-04
 */
public interface ITaskInfoService
{
    /**
     * 查询任务信息
     *
     * @param id 任务信息键
     * @return 任务信息
     */
    public TaskInfo selectTaskInfoById(Long id);

    /**
     * 查询任务信息列表
     *
     * @param taskInfo 任务信息
     * @return 任务信息集合
     */
    public List<TaskInfo> selectTaskInfoList(TaskInfo taskInfo);

    /**
     * 新增任务信息
     *
     * @param taskInfoCreateVO 任务信息
     * @return 结果
     */
    public int insertTaskInfo(TaskInfoCreateVO taskInfoCreateVO);

    /**
     * 修改任务信息
     *
     * @param taskInfo 任务信息
     * @return 结果
     */
    public int updateTaskInfo(TaskInfo taskInfo);

    /**
     * 批量删除任务信息
     *
     * @param ids 需要删除的任务信息键集合
     * @return 结果
     */
    public int deleteTaskInfoByIds(Long[] ids);

    /**
     * 删除任务信息信息
     *
     * @param id 任务信息键
     * @return 结果
     */
    public int deleteTaskInfoById(Long id);


    void doCreateAudit(TaskCreateAuditReqVO taskCreateAuditReqVO);
    void appDoCreateAudit(TaskCreateAuditReqVO taskCreateAuditReqVO);

    void dofinishAudit(TaskFinishAuditReqVO taskFinishAuditReqVO);
    void appDofinishAudit(TaskFinishAuditReqVO taskFinishAuditReqVO);

    TaskAuditInfoVO getTaskCreateAuditInfo(Long taskId);

    TaskAuditInfoVO getTaskFinishAuditInfo(Long taskId);

    int updateSpotCheck(@Valid TaskSpotCheckUpdateReqVO req);

    List<TaskInfo> selectPendingTasksForGen(Long companyId, Long departmentId, List<Long> taskTypeIds);

    List<TaskStatsDTO> getTaskCompleteStats(GetTaskCompleteStatsVO param);
    List<TaskStatsDTO> getTaskCreateStats(GetTaskCompleteStatsVO param);
    BigDecimal getTaskCompleteStatsCount(GetTaskCompleteStatsVO param);
    BigDecimal getTaskCreateStatsCount(GetTaskCompleteStatsVO param);

    List<TaskInfo> selectTaskInfoByIds(List<Long> taskIds);

    // 综合查询文章相关信息
    TaskDeliveryDto getTaskDelivery(Long taskIds);

    /**
     * 复制创建任务
     *
     * @param taskId 原任务ID
     * @return 新任务ID
     */
    Long copyCreateTask(Long taskId);

}
